// =============================================================================
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011 - DIGITEO - Cedric DELAMARRE
//
//  This file is distributed under the same license as the Scilab package.
// =============================================================================

//==============================================================================
// Benchmark for complex addition on GPU and CPU
//==============================================================================


stacksize('max');
tmp=ones(4,2);

k=250;
m=250;
n=250;

a=rand(m,k)+rand(m,k)*%i;
b=rand(k,n)+rand(k,n)*%i;
tic();gpuRes=gpuAdd(a,b);  tmp(1,1)=toc();
tic();cpuRes=a+b;          tmp(1,2)=toc();

k=500;
m=500;
n=500;
a=rand(m,k)+rand(m,k)*%i;
b=rand(k,n)+rand(k,n)*%i;
tic();gpuRes=gpuAdd(a,b);  tmp(2,1)=toc();
tic();cpuRes=a+b;          tmp(2,2)=toc();

k=1000;
m=1000;
n=1000;
a=rand(m,k)+rand(m,k)*%i;
b=rand(k,n)+rand(k,n)*%i;
tic();gpuRes=gpuAdd(a,b);  tmp(3,1)=toc();
tic();cpuRes=a+b;          tmp(3,2)=toc();

k=2000;
m=2000;
n=2000;
a=rand(m,k)+rand(m,k)*%i;
b=rand(k,n)+rand(k,n)*%i;
tic();gpuRes=gpuAdd(a,b);  tmp(4,1)=toc();
tic();cpuRes=a+b;          tmp(4,2)=toc()

